#include "DataTransferObject.h"

using namespace nemo;

namespace cca {

DataTransferObject::DataTransferObject() {
}

DataTransferObject::~DataTransferObject() {
}

std::string DataTransferObject::print() const {
    std::string str;
    str = "<DataTransferObject>";
    return str;
}

std::ostream& operator<<(std::ostream& os, const DataTransferObject& dto) {
    os.precision(3); // Precision when printing double values
    os << dto.print();
    return os;
}

ContainingDoubles::ContainingDoubles() :
    _dimension(), _values() {
}

ContainingDoubles::ContainingDoubles(unsigned int dimension) :
    _dimension(dimension), _values(dimension) {
}

ContainingDoubles::ContainingDoubles(nemo::RealVector values) :
    _dimension(values.dimension()), _values(values) {
}

ContainingDoubles::~ContainingDoubles() {
}

unsigned int ContainingDoubles::getDimension() const {
    return this->_dimension;
}

double ContainingDoubles::asDouble() const {
    if (this->_dimension == 1) {
        return this->asDouble(0);
    } else {
        throw std::invalid_argument(
                "Data transfer object multi-dimensional, but no dimension given.");
    }
}

double ContainingDoubles::asDouble(unsigned int index) const {
    if (index >= this->_dimension) {
        throw std::invalid_argument("Index exceeds dimension.");
    }
    return this->_values[index];
}

RealVector ContainingDoubles::asDoubleVector() const {
    return this->_values;
}

}
