#include "Status.h"

namespace cca {

Status::Status() {
}

Status::~Status() {
}

bool Status::empty() const {
    return _empty();
}

bool Status::_empty() const {
    return true;
}

SingleValue::SingleValue(double value) :
    Status(), _value(value) {
}

SingleValue::~SingleValue() {
}

bool SingleValue::_empty() const {
    return false;
}

double SingleValue::getValue() const {
    return _value;
}

void SingleValue::setValue(double value) {
    _value = value;
}

ThreeValues::ThreeValues(double value1, double value2, double value3) :
    Status(), _value1(value1), _value2(value2), _value3(value3) {
}

ThreeValues::~ThreeValues() {
}

bool ThreeValues::_empty() const {
    return false;
}

double ThreeValues::getValue(unsigned int i) const {
    switch (i) {
    case 0:
        return _value1;
    case 1:
        return _value2;
    case 2:
        return _value3;
    default:
        return _value1;
    }
}

void ThreeValues::setValue(unsigned int i, double value) {
    switch (i) {
    case 0:
        _value1 = value;
    case 1:
        _value2 = value;
    case 2:
        _value3 = value;
    default:
        _value1 = value;
    }
}

std::ostream& operator<<(std::ostream& os, const SingleValue& status) {
    os.precision(3); // Precision when printing double values
    os << "SingleValue (" << status._value << ")" << std::endl;
    return os;
}

std::ostream& operator<<(std::ostream& os, const ThreeValues& status) {
    os.precision(3); // Precision when printing double values
    os << "ThreeValues (" << status._value1 << ", " << status._value2 << ", "
            << status._value3 << ")" << std::endl;
    return os;
}

}
