#pragma once

#include <string>
#include <iostream>

#include "cca/Config.h"

namespace cca {

/**
 * Simple Status
 */
class Status {
public:
    Status();
    virtual ~Status();
    bool empty() const;
    virtual bool _empty() const;
};

/**
 * Single-Value Status
 */
class SingleValue: public Status {
public:
    SingleValue(double value);
    virtual ~SingleValue();
    bool _empty() const;
    double getValue() const;
    void setValue(double value);

    /**
     * Stream operator
     * @param os
     * @param node
     * @return
     */
    friend std::ostream
    & operator<<(std::ostream& os, const SingleValue& status);
protected:
    double _value;
};

/**
 * Three-Values Status
 */
class ThreeValues: public Status {
public:
    ThreeValues(double value1, double value2, double value3);
    virtual ~ThreeValues();
    bool _empty() const;
    double getValue(unsigned int i) const;
    void setValue(unsigned int i, double value);

    /**
     * Stream operator
     * @param os
     * @param node
     * @return
     */
    friend std::ostream
    & operator<<(std::ostream& os, const ThreeValues& status);
protected:
    double _value1;
    double _value2;
    double _value3;
};

}
