#include "Task.h"

using namespace nemo;

namespace cca {

Task::Task() {
}

Task::~Task() {
}

bool Task::empty() const {
    return _empty();
}

bool Task::_empty() const {
    return true;
}

ComplexTask::ComplexTask(unsigned int dimension) :
    Task(), _dimension(dimension), _values(dimension) {
}

ComplexTask::~ComplexTask() {
}

bool ComplexTask::_empty() const {
    return false;
}

unsigned int ComplexTask::getDimension() const {
    return this->_dimension;
}

double ComplexTask::getValue(unsigned int i) const {
    return this->_values[i];
}

void ComplexTask::setValue(unsigned int i, double value) {
    if (i < _dimension) {
        this->_values[i] = value;
    }
}

SingleTask::SingleTask() :
    ComplexTask(1) {
}

SingleTask::SingleTask(double value) :
    ComplexTask(1) {
    this->_values[0] = value;
}

SingleTask::~SingleTask() {
}

double SingleTask::getValue(unsigned int i) const {
    return this->_values[i];
}


void SingleTask::setValue(unsigned int i, double value) {
    this->_values[i] = value;
}

std::ostream& operator<<(std::ostream& os, const ComplexTask& task) {
    os.precision(3); // Precision when printing double values
    os << "ComplexTask, " << task._dimension << "-dim. (";
    for (unsigned int i = 0; i < task._dimension; ++i) {
        os << task.getValue(i) << ", ";
    }
    os << ")" << std::endl;
    return os;
}

std::ostream& operator<<(std::ostream& os, const SingleTask& task) {
    os.precision(3); // Precision when printing double values
    os << "SingleTask (Value: " << task.getValue(0) << ")" << std::endl;
    return os;
}

}
