#pragma once

#include <string>
#include <iostream>

// Mathdata
#include <NemoMath/Vector.h>

#include "cca/Config.h"

namespace cca {

/**
 * Simple Task
 */
class Task {
public:
    Task();
    virtual ~Task();
    bool empty() const;
    virtual bool _empty() const;
};

/**
 * Complex Task
 */
class ComplexTask: public Task {
public:
    ComplexTask(unsigned int dimension);
    ~ComplexTask();
    unsigned int getDimension() const;
    double getValue(unsigned int i = 0) const;
    void setValue(unsigned int i = 0, double value = 0);

    /**
     * Stream operator
     * @param os
     * @param node
     * @return
     */
    friend std::ostream
    & operator<<(std::ostream& os, const ComplexTask& task);
protected:
    bool _empty() const;
    unsigned int _dimension;
    nemo::RealVector _values;
};

class SingleTask: public ComplexTask {
public:
    SingleTask();
    SingleTask(double value);
    ~SingleTask();
    double getValue(unsigned int i = 0) const;
    void setValue(unsigned int i = 0, double value = 0);

    /**
     * Stream operator
     * @param os
     * @param node
     * @return
     */
    friend std::ostream
    & operator<<(std::ostream& os, const SingleTask& task);
};

}
