#pragma once

#include <iostream>
#include <sstream>
#include <math.h>
#include <boost/shared_ptr.hpp>

#include "cca/dto/DataTransferObject.h"

namespace cca {

class DebugDTO;
typedef boost::shared_ptr<DebugDTO> DebugDTOPtr;

/**
 * Domain transfer object for debugging purposes. No semantic meaning.
 * @ingroup DTO
 */
class DebugDTO: public DataTransferObject, public ContainingDoubles {

public:
    DebugDTO();
    DebugDTO(nemo::RealVector values);

    /**
     * Print function
     */
    virtual std::string print() const;

    /**
     * Shared Pointer Factory
     */
    static DebugDTOPtr create(nemo::RealVector values);
};

}
