#pragma once

#include <string>
#include <iostream>

// Include FastFlow gatherer to have all necessary tools included
#include <ff/node.hpp>
#include <ff/farm.hpp>
#include <ff/gt.hpp>

#include "cca/Config.h"
#include "cca/dto/Status.h"
#include "MCSP.h"

namespace cca {

/**
 * Collector node
 * @todo Use FastFlow gatherer with modified filter
 */
class Collector: public MCSPNode {
public:
    Collector(std::string nodename, unsigned int numInputNodes = 6, bool timed = false,
            unsigned int samplerate = 1);
    ~Collector();

    virtual void registerInputNode(CCANode* inputNode);

    /**
     * Stream operator
     * @param os
     * @param node
     * @return
     */
    friend std::ostream
    & operator<<(std::ostream& os, const Collector& node);

protected:

    /**
     * The actual working
     * This could mean just passing the task to all registered _receivers.
     */
    virtual void* process(void *task);

    /**
     * Collect tasks from all registered inputs
     */
    virtual void* collectTasks();

    ThreeValues _status;
};

}
