#include "Junction.h"

using namespace std;

namespace cca {

Junction::Junction(string nodename, unsigned int num_receivers, bool timed,
        unsigned int samplerate) :
    SCMPNode(nodename, timed, samplerate, num_receivers) {
}

Junction::~Junction() {
}

void Junction::prepare() {
    // Input buffer
}

void* Junction::process(void *task) {
    //std::cout << "Junction >" << _nodename << "<::process"
    //      << std::endl;
    // Broadcasting to all registered receivers
    // TODO: Use vector iterator
    for (unsigned int index; index < this->_receivers.size(); ++index) {
        this->_receivers[index]->svc(task);
    }
    return task;
}

JunctionPtr Junction::create(std::string nodename, unsigned int num_receivers,
        bool timed, unsigned int samplerate) {
    JunctionPtr jnc(new Junction(nodename, num_receivers, timed, samplerate));
    return jnc;
}

string Junction::print() const {
    ostringstream outstream(ostringstream::out);
    outstream.precision(3); // Precision when printing double values
    outstream << "<Junction \"" << this->_nodename << "\"";
    if (this->_timed) {
        outstream << ", timed (samplerate=" << this->_sampleRate << ")";
    }
    outstream << ", " << this->_nReceivers << " registered receivers>" << endl;
    return outstream.str();
}

}
