#pragma once

#include <string>
#include <iostream>

#include "cca/Config.h"
#include "SCMP.h"

namespace cca {

class Junction;
typedef boost::shared_ptr<Junction> JunctionPtr;

/**
 * Junction Node
 * Multiplying the received task to all outgoing nodes.
 * @todo That is not a skeleton yet, but does it by hand
 * @todo Use FastFlow load balancer with broadcast
 */
class Junction: public SCMPNode {
public:
    Junction(std::string nodename, unsigned int num_receivers,
            bool timed = false, unsigned int samplerate = 1);
    ~Junction();

    /**
     * The actual working
     * This could mean just passing the task to all registered _receivers.
     */
    virtual void* process(void *task);

    /**
     * Printing the node
     */
    std::string print() const;

    /**
     * Shared Pointer Factory
     */
    static JunctionPtr create(std::string nodename, unsigned int num_receivers,
            bool timed = false, unsigned int samplerate = 1);

protected:
    /**
     * Prepare input and output buffers
     */
    virtual void prepare();
};

}
