#include "RandomNumberGenerator.h"

using namespace std;

namespace cca {

RandomNumberGenerator::RandomNumberGenerator(std::string nodename, bool timed,
        unsigned int samplerate) :
    CCANode(nodename, timed, samplerate), _lower(0), _upper(1), _number(0) {
}

RandomNumberGenerator::~RandomNumberGenerator() {
}

void RandomNumberGenerator::setRange(double lower, double upper) {
    this->_upper = upper;
    this->_lower = lower;
}

void RandomNumberGenerator::limitNumber(unsigned int number) {
    this->_number = (int) number;
}

string RandomNumberGenerator::print() const {
    ostringstream outstream(ostringstream::out);
    outstream.precision(3); // Precision when printing double values
    outstream << "<RandomNumberGenerator \"" << this->_nodename << "\"";
    outstream << ", range is [" << this->_lower << ", " << this->_upper << "]";
    outstream << ">" << endl;
    return outstream.str();;
}

RandomNumberGeneratorPtr RandomNumberGenerator::create(string name, bool timed,
        unsigned int samplerate) {
    RandomNumberGeneratorPtr rng(
            new RandomNumberGenerator(name, timed, samplerate));
    return rng;
}

void* RandomNumberGenerator::process(void *task) {
    //std::cout << "RandomNumberGenerator >" << _nodename << "<::process"
    //      << std::endl;
    if (this->_number < 0) {
        // Stop requested
        return EOS;
    }

    // TODO: FIX THIS
    nemo::RealVector random(1, this->_lower);
    DebugDTO *dto = new DebugDTO(random);

    return dynamic_cast<void*> (dto);
}

void RandomNumberGenerator::onBeat() {
    std::cout << "RNG ON BEAT CALLED (" << this->_sentCounter << ")"
            << std::endl;
    if ((this->_number > 0) && (this->_sentCounter >= this->_number)) {
        // Stop requested
        this->_number = -1;
    }
}

}
